{
  //Script to be run in ROOT to generate dlls.
  //
  //Typical use...
  // root -l -x CompileCodes.cpp
  //

  //ROOT incorrectly sets a few of the compiler options.  This
  //corrects for those errors.  (Removes -MD -GR -EHa -W3 and adds
  //-EHsc).
  //
  //The script also strips out the following...
  //
  //&& if EXIST "$BuildDir\$LibName.dll.manifest" ( mt-nologo
  //-manifest "$BuildDir\$LibName.dll.manifest"
  //"-outputresource:$BuildDir\$LibName.dll;2" && del
  //"$BuildDir\$LibName.dll.manifest" )
  //
  //Which I don't understand.
  TString opt;
  opt = "cl $Opt -nologo -TP -c -nologo -FIw32pragma.h -EHsc";
  opt += " -Iinclude   -D_WIN32_WINNT=0x0400 $IncludePath  $SourceFiles";
  opt += " -Fo$ObjectFiles && bindexplib $LibName $ObjectFiles > ";
  opt += "$BuildDir\\$LibName.def && lib -nologo -MACHINE:IX86 ";
  opt += "-out:$BuildDir\\$LibName.lib $ObjectFiles ";
  opt += "-def:$BuildDir\\$LibName.def && link -nologo $ObjectFiles"; 
  opt += " -DLL -nologo -ignore:4049,4075,4217,4221 -incremental:no  ";
  opt += " -out:$BuildDir\\$LibName.dll $BuildDir\\$LibName.exp";
  opt += " -LIBPATH:%ROOTSYS%\\lib  $LinkedLibs libCore.lib libCint.lib";
  opt += " kernel32.lib advapi32.lib user32.lib gdi32.lib comdlg32.lib";
  opt += " winspool.lib";
  gSystem->SetMakeSharedLib(opt);

  //This changes the directory where the dll, lib, exp, and def file
  //get written to.  The files do not get dumped direclty here but
  //this is the base directory where the source file structure will
  //get mapped to.  Example if LVehicle is in a directory like
  //c:/root/src/Vehicle then its files will be put into
  //./src/dlls/root/src/Vehicle
  gSystem->SetBuildDir("./dlls");

  //Here is where the files get loaded (.L), compiled (+), even if
  //current (++), and optimized (O).  All the files I currently know
  //about (Dec 14, 2006) are here.  As new classes get added then they
  //should be added.  If you only want to work with part of the code
  //(i.e. Ludlum but not SAIC) then feel free to comment out those
  //unneeded classes.

  gSystem->SetIncludePath("-I$ROOTSYS/include -I.); 


  //Utility Classes (for SAIC)
  gROOT->ProcessLine(".L ./Table.cpp++O");     
  gROOT->ProcessLine(".L ./Vehicle.cpp++O");     
}  
