{

  gSystem->Load("Table_cpp");
  gSystem->Load("Vehicle_cpp");

  gROOT->Reset();
  TFile *rootFile = NULL;
  
  TTree *tree = NULL;
  Vehicle *ptr = NULL;
  rootFile = new TFile("Vehicle.root", "READ");
  tree = (TTree*)rootFile->Get("car");
  tree->SetBranchAddress("car",&(ptr));

  /* how many cars are stored in the branch? */
  Long64_t  numberOfCars = tree->GetEntries();
  std::cout << "number of cars: " << numberOfCars << std::endl;
  
  
  /* read every car that is in the branch of the tree */
  for (Long64_t i=0; i<numberOfCars; i++) 
    {
      tree->GetEntry(i);
      
      
      /* process the retrieved Vehicle */        
      cout << "Vehicle[" << i << "]:"
	   <<"parameter=" << ptr->parameter << " ";
      cout << endl;
    
      //ptr->v is a vector of RSPs
      for (int indexRsp=0; indexRsp<ptr->v.size(); indexRsp++) 
	{
	  //extract one rsp
	  vector<Table> rsp = (vector<Table>)ptr->v[indexRsp];
	  //rps is a vector of segments
	  for (int indexSegment=0; indexSegment<rsp.size(); indexSegment++) 
	    {
	      //extract one segment
	      Table segment = (Table)rsp[indexSegment];
	      //segment contains rows
	      for (int indexRow=0; indexRow<segment.v.size(); indexRow++) 
		{
		  //extract one row
		  int row = segment.v[indexRow];
		  cout << "vector[" << indexRsp << "][" << indexSegment << "][" << indexRow << "]=" << row << endl;
		}
	    }
	  
	}
      cout << endl;
    }
}
